// plgsmpl3.cpp
//

#include "stdafx.h"
#include "plgsmpl3.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlgsmpl3App

BEGIN_MESSAGE_MAP(CPlgsmpl3App, CWinApp)
	//{{AFX_MSG_MAP(CPlgsmpl3App)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlgsmpl3App

CPlgsmpl3App::CPlgsmpl3App()
{
}

CPlgsmpl3App theApp;


/////////////////////////////////////////////////////////////////////////////
// CSettingDlg

CSettingDlg::CSettingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSettingDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSettingDlg)
	m_strData = _T("");
	//}}AFX_DATA_INIT
}


void CSettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingDlg)
	DDX_Text(pDX, IDC_EDIT1, m_strData);
	DDV_MaxChars(pDX, m_strData, 255);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingDlg, CDialog)
	//{{AFX_MSG_MAP(CSettingDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#include <string.h>
#include "mpplugin.h"

#include "plgclone.h"

#include "resource.h"

#define PLG_FNC_NAME "Plugin with User Option"
PLUGGEDIN_EXPORT( long ) PLG_ExecuteCommand(PLUGGEDIN_STRUCT *ps)
{
	AFX_MANAGE_STATE( AfxGetStaticModuleState() );
    
	if (DWPC_FindRegistryKey(ps->ps_pszFunction)==FALSE)
	    return 0;
    
    int nSize=0;
    nSize=    DWPC_GetRegistryData(ps->ps_pszFunction,NULL,0);
    if (nSize<1)
        return 0;

    char *buf=new char[nSize];
    char *buf2= new char[nSize+64];
    nSize=    DWPC_GetRegistryData(ps->ps_pszFunction,buf,nSize);

    sprintf(buf2,"<<%s>>\nData: %s\n",ps->ps_pszFunction, buf);

    AfxMessageBox(buf2);

    delete buf;
    delete buf2;

    return 1;
}

PLUGGEDIN_EXPORT( long ) PLG_EnumerateCommands(char* pszEntries, long nBufSize, long* pnRealSize)
{
    *pnRealSize=strlen(PLG_FNC_NAME)+1;

    if (nBufSize<*pnRealSize)
        return 0;

    strcpy(pszEntries, PLG_FNC_NAME);

	return 1;
}

PLUGGEDIN_EXPORT( long ) PLG_Executable(const char *pszFunction, long nSel)
{
	return 1;
}
PLUGGEDIN_EXPORT( long ) PLG_RequireFiles(const char *pszFunction)
{
	return 1;
}

PLUGGEDIN_EXPORT( HICON ) PLG_GetCommandIcon(const char *pszFunction, long bNormal)
{
	AFX_MANAGE_STATE( AfxGetStaticModuleState() );
	HICON hIcon=NULL;
	unsigned resID=IDI_ICON1;

	HINSTANCE myInst = (HINSTANCE) AfxGetInstanceHandle();
	if (bNormal)
		hIcon=LoadIcon(myInst,MAKEINTRESOURCE(resID));
	else
		hIcon=(HICON)LoadImage(myInst,MAKEINTRESOURCE(resID),IMAGE_ICON,16,16,0);
	return hIcon;
}

PLUGGEDIN_EXPORT( long ) PLG_Initialize(const char* cmd)
{
	return 1;
}

PLUGGEDIN_EXPORT( long ) PLG_Finalize(const char*  cmd)
{
	return 1;
}


PLUGGEDIN_EXPORT( long ) PLG_IsParallel(const char *pszFunction)
{
	return 0;
}


PLUGGEDIN_EXPORT( long ) PLG_CanSetProfile(const char *pszFunction)
{
	return 1;
}

PLUGGEDIN_EXPORT( long ) PLG_SetProfile(const char *pszFunction)
{
	AFX_MANAGE_STATE( AfxGetStaticModuleState() );
    CSettingDlg dlg;
    int nDataSize=0;
    char* data=NULL;

    nDataSize=DWPC_GetRegistryData(pszFunction,NULL,0);
    if (nDataSize>1){
        data=new char[nDataSize];
        nDataSize=DWPC_GetRegistryData(pszFunction,data,nDataSize);
    }
    else{
        data=new char[32];
        strcpy(data,"Sample: xxxxx");
    }
    dlg.m_strData=data;
    BOOL bRes=(dlg.DoModal()==IDOK);
    if (bRes==TRUE){
        nDataSize=dlg.m_strData.GetLength()+1;
        DWPC_SetRegistryData(pszFunction,dlg.m_strData,nDataSize);
    }
    delete data;

    return (bRes==TRUE)?1:0;
}


PLUGGEDIN_EXPORT( long ) PLG_IsCloningCommand(const char *pszFunction)
{
    return 1;
}

PLUGGEDIN_EXPORT( long ) PLG_GetNewClone(char* pszNewClone, long bufsize)
{
    int nLen=strlen(pszNewClone);
    char* pszCloneBody=NULL;
    char *data=NULL;
    int nDataSize=0;
    if (DWPC_FindRegistryKey(pszNewClone)){
        nDataSize=DWPC_GetRegistryData(pszNewClone,NULL,0);
        if (nDataSize>0){
            data=new char[nDataSize];
            nDataSize=DWPC_GetRegistryData(pszNewClone,data,nDataSize);
        }
        int nID;
        pszCloneBody=new char[nLen*2];
        DWPC_GetCloneIDFromCommand(pszNewClone,pszCloneBody,&nID);
    }

    char *tmp=new char[nLen*2];
	int i=0;
    for (i=0;i<MAX_PLUGGEDIN_NUMBER;i++){
        if (pszCloneBody)
            DWPC_CreateInstanceString(pszCloneBody, i, tmp);
        else
            DWPC_CreateInstanceString(PLG_FNC_NAME, i, tmp);
        if (DWPC_FindRegistryKey(tmp)==FALSE)
            break;
    }
    
    long result=1;

    if (i<MAX_PLUGGEDIN_NUMBER){
        if (DWPC_AllocateRegistryKey(tmp)==FALSE)
            result=0;
        if (result){
            if (data ){
                if ( DWPC_SetRegistryData(tmp,data,nDataSize)==FALSE ){
                    DWPC_ReleaseRegistryKey(tmp);
                    result=0;
                }
            }
        }
        if (result){
            if (bufsize>=(int)strlen(tmp))
                strcpy(pszNewClone, tmp);
            else
                result=0;
        }
    }
    else{
        result=0;
    }

    if (pszCloneBody)
        delete pszCloneBody;
    if (data)
        delete data;
    if (tmp)
        delete tmp;
    return result;
}

PLUGGEDIN_EXPORT( long ) PLG_ReleaseClone(const char* pszClone)
{
    DWPC_ReleaseRegistryKey(pszClone);
    return 0;
}


PLUGGEDIN_EXPORT( long ) PLG_CanFinalize(const char* pszClone)
{
    return 1;
}
